package javax.swing.text.rtf;

import java.util.Enumeration;
import java.util.Dictionary;
import javax.swing.text.MutableAttributeSet;
import javax.swing.text.AttributeSet;

class MockAttributeSet implements AttributeSet, MutableAttributeSet
{
    public Dictionary<Object, Object> backing;
    
    MockAttributeSet() {
    }
    
    public boolean isEmpty() {
        return this.backing.isEmpty();
    }
    
    @Override
    public int getAttributeCount() {
        return this.backing.size();
    }
    
    @Override
    public boolean isDefined(Object o) {
        return this.backing.get(o) != null;
    }
    
    @Override
    public boolean isEqual(AttributeSet set) {
        throw new InternalError("MockAttributeSet: charade revealed!");
    }
    
    @Override
    public AttributeSet copyAttributes() {
        throw new InternalError("MockAttributeSet: charade revealed!");
    }
    
    @Override
    public Object getAttribute(Object o) {
        return this.backing.get(o);
    }
    
    @Override
    public void addAttribute(Object o, Object o2) {
        this.backing.put(o, o2);
    }
    
    @Override
    public void addAttributes(AttributeSet set) {
        Enumeration<Object> attributeNames = set.getAttributeNames();
        while (attributeNames.hasMoreElements()) {
            Object nextElement = attributeNames.nextElement();
            this.backing.put(nextElement, set.getAttribute(nextElement));
        }
    }
    
    @Override
    public void removeAttribute(Object o) {
        this.backing.remove(o);
    }
    
    @Override
    public void removeAttributes(AttributeSet set) {
        throw new InternalError("MockAttributeSet: charade revealed!");
    }
    
    @Override
    public void removeAttributes(Enumeration<?> enumeration) {
        throw new InternalError("MockAttributeSet: charade revealed!");
    }
    
    @Override
    public void setResolveParent(AttributeSet set) {
        throw new InternalError("MockAttributeSet: charade revealed!");
    }
    
    @Override
    public Enumeration getAttributeNames() {
        return this.backing.keys();
    }
    
    @Override
    public boolean containsAttribute(Object o, Object o2) {
        throw new InternalError("MockAttributeSet: charade revealed!");
    }
    
    @Override
    public boolean containsAttributes(AttributeSet set) {
        throw new InternalError("MockAttributeSet: charade revealed!");
    }
    
    @Override
    public AttributeSet getResolveParent() {
        throw new InternalError("MockAttributeSet: charade revealed!");
    }
}
